//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

// $Header: fsgetfilename.c,r42 2006-02-18 04:23:47 ingo $


#include "fsyspriv.h"


// RETURN TYPE OF PATH
// 1 == Name include drive
// 2 == Name include path
// 4 == Path is absolute
// 8 == File ends in slash
// 16== Drive is HP style
// 32== Name is empty
// BITS 16-31 = DEPTH OF PATH (0=CURRENT DIR OR ROOT)


char *FSGetFileName(FS_FILE *file,int flags)
{
char *ptr,*partial,*tmp;
FS_FILE *dir,*enddir=NULL;
int length=1;

// COMPUTE STRING LENGTH

if( !(flags&FSNAME_EMPTY) && (file->Name!=NULL)) length+=(int)strlen(file->Name);

if(flags&FSNAME_HASPATH) {
if(!(flags&FSNAME_ABSPATH)) enddir=FSystem.Volumes[file->Volume]->CurrentDir;
dir=file->Dir;
while(dir && (dir!=enddir))
{
if(dir->Name!=NULL) length+=(int)strlen(dir->Name)+1;
dir=dir->Dir;
}
if(dir==NULL) flags|=FSNAME_ABSPATH;	// FORCE ABSOLUTE PATH
}

if(flags&FSNAME_ABSPATH) ++length;
if(flags&FSNAME_ENDSLASH) ++length;
if(flags&FSNAME_HASVOL) {
length+=2;
if(flags&FSNAME_VOLHP) ++length;
}

// ALLOCATE THE STRING
ptr=(char *)malloc(length);
if(!ptr) return NULL;

// GENERATE NAME
partial=ptr;

// VOLUME INFORMATION
if(flags&FSNAME_HASVOL) {
if(flags&FSNAME_VOLHP) { *partial=':'; ++partial; }
partial[0]='3'+file->Volume;
partial[1]=':';
partial+=2;
}

// STARTING SLASH IF ABSOLUTE PATH

if(flags&FSNAME_ABSPATH) { *partial='\\'; ++partial; }

*partial=0;

if(flags&FSNAME_HASPATH) {
dir=file->Dir;
while(dir && (dir!=enddir))
{
if(dir->Name!=NULL) {
// MAKE ROOM
memmove(partial+strlen(dir->Name)+1,partial,strlen(partial)+1);
strcpy(partial,dir->Name);
tmp=partial;
while(*tmp!=0) ++tmp;
*tmp='\\';
}
dir=dir->Dir;
}
while(*partial) ++partial;
}


if(!(flags&FSNAME_EMPTY))
{
if(file->Name!=NULL) strcpy(partial,file->Name);
while(*partial) ++partial;
}

if(flags&FSNAME_ENDSLASH) {
if(*(partial-1)!='\\') {
*partial='\\';
++partial;
}
}
else {
if(*(partial-1)=='\\') --partial;
}
*partial=0;

return ptr;
}
