//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file as well as the entire HPG library was written by Chris Smith
//& for HPGCC 1.0, now maintained by the HPGCC3 team.
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#include "hpgraphics.h"
#include "hpgpriv.h"

void hpg_blit(hpg_t *src, int sx, int sy, int w, int h,
              hpg_t *dst, int dx, int dy)
{
    hpg_init();

    if(src==NULL) src=HPG_STDSCREEN;
    if(dst==NULL) dst=HPG_STDSCREEN;
    
    unsigned char saved_color = dst->color;

    int xoff = dx - sx;
    int yoff = dy - sy;

    int x, y;
    for (x = sx; x < sx + w; x++)
    {
        int tx = x + xoff;
        for (y = sy; y < sy + h; y++)
        {
            int ty = y + yoff;
            dst->color = hpg_get_pixel(src, x, y);
            hpg_draw_pixel_on(dst, tx, ty);
        }
    }

    dst->color = saved_color;
}
