//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file as well as the entire HPG library was written by Chris Smith
//& for HPGCC 1.0, now maintained by the HPGCC3 team.
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#include <stddef.h>
#include "hpgraphics.h"
#include "hpgpriv.h"

void hpg_draw_letter_on(hpg_t *g, char a, int x, int y)
{
    hpg_init();
    if(g==NULL) g=HPG_STDSCREEN;
    if (g->font == NULL) g->font = hpg_get_minifont();

    if (a >= g->font->count) return;

    struct hpg_pattern charpat = {
        NULL, g->font->height, 0
    };

    struct hpg_pattern *oldpat = g->pattern;
    g->pattern = &charpat;

    charpat.buffer = g->font->buffer + (g->font->height * a);
    hpg_fill_rect_on(g, x, y, x + g->font->advance - 1, y + g->font->height - 1);

    g->pattern = oldpat;
}
