//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***




#include <hpgcc3.h>

// CONVERT STRING TO BASE-10 REAL
// RETURNS POINTER TO CHARACTER WHEN STOPS

char *xr_atoxr(const char *str,XREAL *res)
{
int sign=0,digit,limit=0;
unsigned long long mant=0;
int exp10=0;
char *ptr;

// READ SIGN
if(*str=='+') ++str;
else { if(*str=='-') { sign=1; ++str; } }

// READ INTEGER PART
ptr=_str2ull(str,&mant,10);
digit=xr_getbasedigit(*ptr,10);
if(digit>=0) {
// PRECISION LIMIT REACHED
	// ROUND LAST DIGIT
	limit=1;
	if(digit>=5) ++mant;
	// SKIP ALL OTHER DIGITS
	while((digit=xr_getbasedigit(*ptr,10))>=0) { ++ptr; ++exp10; }
}

// READ FRACTION
if(*ptr=='.') {

		++ptr;
		// GET FRACTION
		if(limit) {	// SKIP FRACTION IF PRECISION LIMIT REACHED
			while((digit=xr_getbasedigit(*ptr,10))>=0) { ++ptr; }
		}
		else {
		str=_str2ull(ptr,&mant,10);
		exp10-=(int)(str-ptr);

		digit=xr_getbasedigit(*str,10);
		if(digit>=0) {
		// PRECISION LIMIT REACHED
			// ROUND LAST DIGIT
			limit=1;
			if(digit>=5) ++mant;
			while((digit=xr_getbasedigit(*str,10))>=0) { ++str;}
		}
		ptr=(char *)str;
		}

}

// READ EXPONENT
if(*ptr=='e' || *ptr=='E')
{
	++ptr;
	int ex2=0;
	unsigned long long val=0;
	if(*ptr=='+') ++ptr;
	else { if(*ptr=='-') { ex2=1; ++ptr; } }
	ptr=_str2ull(ptr,&val,10);
	if(ex2) exp10-=val;
	else exp10+=val;
}

// LEFT-JUSTIFY
while((mant!=0) && (mant<=1844674407370955161LL)) {
mant*=10;
--exp10;
}

	res->Sign=sign;
	res->Mant=mant;
	res->Exp=exp10;
	return ptr;


}
