//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***




#include <hpgcc3.h>


void xr_div(XREAL *num,XREAL *div,XREAL *result)
{
int resexp=0,carry=0;
unsigned long long nmant,dmant,resmant=0;



nmant=num->Mant;
dmant=div->Mant;

if(nmant<dmant) --resexp;

result->Exp=num->Exp-div->Exp+resexp-63;
result->Sign=num->Sign^div->Sign;

if(!nmant && !dmant) {
// RETURN +/-NAN
result->Mant=0;
result->Exp=(1<<29);
return;
}
if(!nmant) {
// 0.0/X = 0.0
result->Mant=0;
result->Exp=-63;
result->Sign=0;
return;
}

if(!dmant) {
// RETURN +/-INF

result->Mant=-1;
result->Exp= (1<<29);
return;
}

while( !(resmant&0x8000000000000000LL))
{
		resmant<<=1;
		if(nmant>=dmant || carry) { resmant|=1; nmant-=dmant; }
		if(nmant&0x8000000000000000LL) carry=1;
		else carry=0;
		nmant<<=1;
		

}

// ROUND LAST DIGIT
if(nmant>dmant || carry) ++resmant;

result->Mant=resmant;
return;
}
