//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***




#include <hpgcc3.h>


void xr_double2xr(double val,XREAL *num)
{
	union {
		double a;
		unsigned long long ul;
		struct { unsigned int lo,hi; } w32;
	} dbl;

	dbl.a=val;

	// WORKAROUND FOR THE BIG-ENDIAN DOUBLE REPRESENTATION IN GCC
	unsigned int temp=dbl.w32.lo;
	dbl.w32.lo=dbl.w32.hi;
	dbl.w32.hi=temp;

	num->Mant=(dbl.ul<<11)|0x8000000000000000LL;
	num->Exp=((dbl.ul>>52)&0x7ff);
	if(num->Exp==2047) {
		// INF/NAN
		num->Mant=~(num->Mant<<1);		// TREATMENT OF NAN/INF IS REVERSED FOR EASIER HANDLING
		num->Exp=(1<<29);	// SPECIAL EXPONENT
	}
	else {
		if(num->Exp==0) {
		// SUBNORMAL NUMBER
				num->Mant<<=1;
		if(num->Mant) {
				num->Exp--;
			while(!(num->Mant&0x8000000000000000LL)) { num->Exp--; num->Mant<<=1; }
			} else
			{
			// NUMBER IS ZERO
			num->Exp=1023;
			}
		}
		num->Exp-=1023+63;
	}
	num->Sign=dbl.ul>>63;

	return;
}
