//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


#include "stdlib.h"
#include "kos.h"
#include <sys.h>
#include <master_globals.h>





//static ULONGLONG __mg->__mwc_w = 0LL;

// ROMLIB CHECKED
// < ibl ; 2006-04-03 >

void
srand_mwc(unsigned int seed)
{
    // FIXME:
    
    // kos call disabled < ibl ; 2007-10-03 >
   //  __mg->__mwc_w = seed ?  seed : sys_RTC_seconds() * kos_GetSysTickTime();
    
    
    if (seed) 
	__mg->__mwc_w = seed;
    else {
	unsigned int salt = tmr_ticks();
	__mg->__mwc_w = salt ? salt * sys_RTC_seconds() : sys_RTC_seconds() ;
    }
}

// optimized version, avoids calling of library functions (performs natively on ARM CPU)
// < ibl ; 2005-05-06 >

unsigned int
mwc(int bits)
{
    
    if(__mg->__mwc_w == 0LL)
        srand_mwc(0);
    
    __mg->__mwc_w = 1517746329LL * (unsigned int) __mg->__mwc_w + (__mg->__mwc_w >> 32);
    return (unsigned int)__mg->__mwc_w >> (32-bits);
}

/*
unsigned int
mwc(int bits)
{
    
    if(__mg->__mwc_w == 0LL)
        srand_mwc(0);
    
    __mg->__mwc_w = 1517746329 * (__mg->__mwc_w & 0xFFFFFFFF) + (__mg->__mwc_w >> 32);
    return (__mg->__mwc_w & 0xFFFFFFFF) >> (32-bits);
}
*/


