//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: sat3_alloc.c 393 2007-03-04 23:17:29Z ingo $

#include <hpgcc3.h>
#include <master_globals.h>




int __sat3_getblockinfo(SAT_OBJECT ptr,SAT_OBJECT *blkstart,int *blksize)
{
int status;
if((ptr&0x60000000)==0x40000000) {
// ARM DOMAIN
char *p=(char *)((ptr>>1)&(~0xf0000000));

void *hstart;
size_t hsize;

status=getheapblockinfo(p,&hstart,&hsize);

if(status!=BLOCK_USED) return INVALID_PTR;

*blkstart=(((SAT_OBJECT)hstart)<<1)|0x40000000;
*blksize=hsize<<1;
return BLOCK_USED;
}

if((ptr&0x60000000)==0) {
// TEMPOB
// ADDRESS IS SATURN VISIBLE, SCAN TEMPOB
SAT_OBJECT ttop=sat3_peek(SAT_TEMPTOP,5);
SAT_OBJECT tbot=sat3_peek(SAT_TEMPOB,5);
SAT_OBJECT tprev;
if(ptr>ttop-5 || ptr<tbot+6) return INVALID_PTR; 

for(tprev=ttop;ttop>=tbot;tprev=ttop,ttop-=sat3_peek(ttop-5,5))
{
if(ptr>ttop && ptr<tprev-5) {
// ADDRESS IS WITHIN THIS BLOCK
*blkstart=ttop+1;
*blksize=tprev-ttop-6;
return BLOCK_USED;
}
if(ptr>=tprev-5) return INVALID_PTR;
}

}

// INVALID OTHERWISE;
return INVALID_PTR;

}



SAT_OBJECT sat3_alloc(SAT_OBJECT where,int size)
{
SAT_OBJECT ptr;

if(where==ALLOC_TEMPOB) return sat3_createtemp(size);
if(where==ALLOC_HEAP) {
ptr=(SAT_OBJECT)malloc( (size+1)>>1);
if(ptr) return (ptr<<1) | 0x40000000;
return 0;
}

// SCAN TEMPOB OR THE HEAP AND VERIFY THERE IS ENOUGH ROOM WITHIN THE BLOCK TO ACCOMODATE size NIBBLES
SAT_OBJECT blk;
int blksize;

if(__sat3_getblockinfo(where,&blk,&blksize)==INVALID_PTR) return 0;	// FAIL IF PTR IS NOT VALID


if(where+size>blk+blksize) return 0;	// NOT ENOUGH SPACE WITHIN CURRENT OBJECT

return where;	// OK TO CREATE

}


