//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: sat3_cstr.c 601 2008-09-01 22:33:13Z claudio $

#include <hpgcc3.h>
#include <master_globals.h>


SAT_OBJECT sat3_createcstr_bytes(SAT_OBJECT where,char *data,int nbytes)
{

    where=sat3_alloc(where,10+2*nbytes);
	if(where==0) return 0;
	
	sat3_poke(where,SAT_DOCSTR,5);
    sat3_poke(where+5,nbytes*2+5,5);
	int addr=where+10;
	
	while(nbytes--) { sat3_poke(addr,*data++,2); addr+=2; }

    return where;
}


BOOL sat3_convertcstr_bytes(SAT_OBJECT cstr,char *data, int maxbytes)
{
int bytes;
if(!cstr) return 0;
if(sat3_isptr(cstr)) cstr=sat3_peek(cstr,5);
if(sat3_peek(cstr,5)!=SAT_DOCSTR) return 0;	// RETURN 0 IF NOT A CSTR
bytes=(sat3_peek(cstr+5,5)-5+1)>>1;

if(bytes>maxbytes) bytes=maxbytes;

cstr+=10;
while(bytes--) { *data++=sat3_peek(cstr,2); cstr+=2; }

return TRUE;
}


SAT_OBJECT sat3_createcstr_str(SAT_OBJECT where,char *string)
{
int len=strlen(string);
    where=sat3_alloc(where,10+2*len);
	if(where==0) return 0;
	
	sat3_poke(where,SAT_DOCSTR,5);
    sat3_poke(where+5,len*2+5,5);
	int addr=where+10;
	
	while(len--) { sat3_poke(addr,*string++,2); addr+=2; }

    return where;
}


BOOL sat3_convertcstr_str(SAT_OBJECT cstr,char *string, int maxchars)
{
int bytes;
if(!cstr) return 0;
if(sat3_isptr(cstr)) cstr=sat3_peek(cstr,5);
if(sat3_peek(cstr,5)!=SAT_DOCSTR) return 0;	// RETURN 0 IF NOT A CSTR
bytes=(sat3_peek(cstr+5,5)-5+3)>>1;		// INCLUDES TRAILING ZERO


if(bytes>maxchars) bytes=maxchars;
if(bytes>0) { 
bytes--;
cstr+=10;
while(bytes--) { *string++=sat3_peek(cstr,2); cstr+=2; }
}
*string=0;

return TRUE;
}

SAT_OBJECT sat3_createcstr_substr(SAT_OBJECT where,char *string, int startpos,int nchars)
{
if(startpos<0) {
nchars+=startpos;
startpos=0;
if(nchars<0) nchars=0;
}
if(nchars>strlen(string)-startpos) nchars=strlen(string)-startpos;
return sat3_createcstr_bytes(where,string+startpos,nchars);

}

// STRING MUST HAVE SPACE FOR NCHARS + TRAILING ZERO

BOOL sat3_convertcstr_substr(SAT_OBJECT cstr,char *string, int startpos,int nchars)
{
int bytes;
if(!cstr) return 0;
if(sat3_isptr(cstr)) cstr=sat3_peek(cstr,5);
if(sat3_peek(cstr,5)!=SAT_DOCSTR) return 0;	// RETURN 0 IF NOT A CSTR
bytes=(sat3_peek(cstr+5,5)-5+1)>>1;		// TRAILING ZERO NOT INCLUDED

if(bytes<startpos) { *string=0; return TRUE; }
if(bytes<startpos+nchars) nchars=bytes-startpos;

cstr+=10+(startpos<<1);
while(nchars--) { *string++=sat3_peek(cstr,2); cstr+=2; }

*string=0;

return TRUE;
}


