//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: sat3_getfreetempob.c 440 2007-08-26 05:49:12Z claudio $

#include <hpgcc3.h>
#include <master_globals.h>

// AUXILIARY FUNCTION
// FINDS PAGE CLOSEST TO RSKTOP USED BY HPGCC
// RETURN 0xffffffff IF NONE, OR SATURN ADDRESS
extern unsigned int sat3_s2a(SAT_OBJECT sat_addr);


SAT_OBJECT __find_main_ram_start(SAT_OBJECT rsktop)
{
int f;


int *ptr=(int *)_mmu_table_addr;
int minaddr=sat3_s2a(rsktop);
unsigned int page=0xffffffff,a;

for(f=0;f<__mg->_mmu_table_entries;++f)
{
a=ptr[f]&0xfffff000;

if(a>minaddr && a<page) page=a;

}

if(page==0xffffffff) return page;
return ((page-minaddr)<<1)+(rsktop&(~1));
}



// AUXILIARY FUNCTION, RETURNS THE AMOUNT OF USEABLE TEMPOB IN NIBBLES

int sat3_getfreetempob()
{

    int rstk=sat3_peek(SAT_RSKTOP,5);
    SAT_OBJECT freeend;

    freeend=__find_main_ram_start((SAT_OBJECT)rstk);
	
    if(freeend==0xffffffff) {
		// C PROGRAM IS NOT USING MAIN RAM
		return sat3_peek(SAT_DSKTOP,5)-rstk-11;
	}

	return freeend-rstk-11;

}


