//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


#include <sys.h>

// ROMLIB CHECKED
#define LCD_TARGET_FREQ 500000



void __lcd_fix()
{
volatile unsigned int *CLKPTR=(unsigned int *)CLK_REGS;
volatile unsigned int *LCDPTR=(unsigned int *)LCD_REGS;
int mpllcon=CLKPTR[1],clkslow=CLKPTR[4],clkdivn=CLKPTR[5];
// INITIAL CLOCK FREQUENCY
int freq=12000000,clkval;

// CALCULATE ACTUAL WORKING CALCULATOR FREQUENCY
if(clkslow&0x10)
{
int slow_val=clkslow&7;
if(slow_val) freq/=slow_val<<1;
}
else {
int mdiv=(mpllcon>>12)&0xff,pdiv=(mpllcon>>4)&0x3f,sdiv=mpllcon&0x3;
freq*=mdiv+8;
freq/=pdiv+2;
freq>>=sdiv;
}
// HERE FREQ=CPU CLOCK FREQUENCY FCLK

if(clkdivn&2) freq/=2;

// HERE FREQ=HCLK 

clkval=freq/LCD_TARGET_FREQ;
clkval+=1;
clkval>>=1; // ROUND TOWARDS SLOWER SPEED


int linecnt,lineblank;

// SET A REASONABLE LINEBLANK FOR SLOW HCLK
lineblank=freq/2000000;

// LCD OFF
LCDPTR[0]&=0xFFFFFFFE;
linecnt=LCDPTR[0]&0xff;
linecnt|=clkval<<8;

// FIX CLKVAL
LCDPTR[0]=linecnt;

// FIX LINEBLANK AND FORCE WDLY=0;
LCDPTR[2]&=0x7ff00;
if(freq>37500000) LCDPTR[2]|=0x080000;
LCDPTR[2]|=lineblank;

// FORCE WLH=0;
LCDPTR[3]&=0xFFFFFF00;
if(freq>37500000) LCDPTR[3]|=1;


// LCD ON
LCDPTR[0]|=1;

}
